const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const save_collections = sequelize.define(
    'save_collections',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

title: {
        type: DataTypes.TEXT,
      
      

      },

is_private: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  save_collections.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity









    db.save_collections.hasMany(db.post_saves, {
      as: 'post_saves_collection',
      foreignKey: {
          name: 'collectionId',
      },
      constraints: false,
    });





















//end loop



    db.save_collections.belongsTo(db.users, {
      as: 'owner',
      foreignKey: {
        name: 'ownerId',
      },
      constraints: false,
    });




    db.save_collections.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.save_collections.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return save_collections;
};


